blob: 25d5c5f6c535f4afe08c6360f5fe3e78e0965974 [file] [log] [blame]
jeffhao5d1ac922011-09-29 17:41:15 -07001#!/bin/bash
2#
3# Copyright (C) 2007 The Android Open Source Project
4#
5# Licensed under the Apache License, Version 2.0 (the "License");
6# you may not use this file except in compliance with the License.
7# You may obtain a copy of the License at
8#
9# http://www.apache.org/licenses/LICENSE-2.0
10#
11# Unless required by applicable law or agreed to in writing, software
12# distributed under the License is distributed on an "AS IS" BASIS,
13# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14# See the License for the specific language governing permissions and
15# limitations under the License.
16
17# Set up prog to be the path of this script, including following symlinks,
18# and set up progdir to be the fully-qualified pathname of its directory.
19prog="$0"
20while [ -h "${prog}" ]; do
21 newProg=`/bin/ls -ld "${prog}"`
22 newProg=`expr "${newProg}" : ".* -> \(.*\)$"`
23 if expr "x${newProg}" : 'x/' >/dev/null; then
24 prog="${newProg}"
25 else
26 progdir=`dirname "${prog}"`
27 prog="${progdir}/${newProg}"
28 fi
29done
30oldwd=`pwd`
31progdir=`dirname "${prog}"`
32cd "${progdir}"
33progdir=`pwd`
34prog="${progdir}"/`basename "${prog}"`
35
36run_args=""
37usage="no"
Dmitry Petrochenko81c56e72014-03-05 15:05:46 +070038sequental="no"
jeffhao5d1ac922011-09-29 17:41:15 -070039
40while true; do
41 if [ "x$1" = "x--host" ]; then
42 run_args="${run_args} --host"
43 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -080044 elif [ "x$1" = "x--jvm" ]; then
45 run_args="${run_args} --jvm"
jeffhao5d1ac922011-09-29 17:41:15 -070046 shift
jeffhao5d1ac922011-09-29 17:41:15 -070047 elif [ "x$1" = "x--debug" ]; then
48 run_args="${run_args} --debug"
49 shift
50 elif [ "x$1" = "x--zygote" ]; then
51 run_args="${run_args} --zygote"
52 shift
jeffhao0dff3f42012-11-20 15:13:43 -080053 elif [ "x$1" = "x--interpreter" ]; then
54 run_args="${run_args} --interpreter"
55 shift
jeffhao5d1ac922011-09-29 17:41:15 -070056 elif [ "x$1" = "x--no-verify" ]; then
57 run_args="${run_args} --no-verify"
58 shift
59 elif [ "x$1" = "x--no-optimize" ]; then
60 run_args="${run_args} --no-optimize"
61 shift
62 elif [ "x$1" = "x--valgrind" ]; then
63 run_args="${run_args} --valgrind"
64 shift
65 elif [ "x$1" = "x--dev" ]; then
66 run_args="${run_args} --dev"
67 shift
68 elif [ "x$1" = "x--update" ]; then
69 run_args="${run_args} --update"
70 shift
71 elif [ "x$1" = "x--help" ]; then
72 usage="yes"
73 shift
Dmitry Petrochenko81c56e72014-03-05 15:05:46 +070074 elif [ "x$1" = "x--seq" ]; then
75 sequental="yes"
76 shift
77 elif [ "x$1" = "x-O" ]; then
78 run_args="${run_args} -O"
79 shift
Zheng Xudc8e7322014-05-07 17:07:20 +010080 elif [ "x$1" = "x--64" ]; then
81 run_args="${run_args} --64"
82 shift
Sebastien Hertz07aaac82014-07-09 15:59:05 +020083 elif [ "x$1" = "x--trace" ]; then
84 run_args="${run_args} --trace"
85 shift
jeffhao5d1ac922011-09-29 17:41:15 -070086 elif expr "x$1" : "x--" >/dev/null 2>&1; then
Elliott Hughes7c046102011-10-19 18:16:03 -070087 echo "unknown $0 option: $1" 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -070088 usage="yes"
89 break
90 else
91 break
92 fi
93done
94
95if [ "$usage" = "yes" ]; then
96 prog=`basename $prog`
97 (
98 echo "usage:"
99 echo " $prog --help Print this message."
100 echo " $prog [options] Run all tests with the given options."
101 echo " Options are all passed to run-test; refer to that for " \
102 "further documentation:"
jeffhao0dff3f42012-11-20 15:13:43 -0800103 echo " --debug --dev --host --interpreter --jvm --no-optimize"
Zheng Xudc8e7322014-05-07 17:07:20 +0100104 echo " --no-verify -O --update --valgrind --zygote --64"
Dmitry Petrochenko81c56e72014-03-05 15:05:46 +0700105 echo " Specific Runtime Options:"
106 echo " --seq Run tests one-by-one, avoiding failures caused by busy CPU"
jeffhao5d1ac922011-09-29 17:41:15 -0700107 ) 1>&2
108 exit 1
109fi
110
Dmitry Petrochenko81c56e72014-03-05 15:05:46 +0700111if [ "$sequental" == "yes" ]; then
112 i=0
113 for test_name in *; do
114 if [ -d "$test_name" -a -r "$test_name" -a -r "$test_name/info.txt" ]; then
115 ./run-test ${run_args} "$test_name"
116 RES=$?
117 test_pids[i]=i
118 test_names[test_pids[i]]="$test_name"
119 if [ "$RES" != "0" ]; then
120 let failure_count+=1
121 failed_test_names="$failed_test_names ${test_names[i]}"
122 else
123 let succeeded_count+=1
124 fi
125 let i+=1
126 fi
127 done
128else
129 # start all the tests
130 i=0
131 for test_name in *; do
132 if [ -d "$test_name" -a -r "$test_name" -a -r "$test_name/info.txt" ]; then
133 ./run-test ${run_args} "$test_name" &
134 test_pids[i]=$!
135 test_names[test_pids[i]]="$test_name"
136 let i+=1
137 fi
138 done
jeffhao5d1ac922011-09-29 17:41:15 -0700139
Dmitry Petrochenko81c56e72014-03-05 15:05:46 +0700140 # wait for all the tests, collecting the failures
141 failure_count=0
142 succeeded_count=0
143 failed_test_names=""
144 for pid in ${test_pids[@]}; do
145 wait $pid
146 if [ "$?" != "0" ]; then
147 let failure_count+=1
148 failed_test_names="$failed_test_names ${test_names[$pid]}[pid=$pid]"
149 else
150 let succeeded_count+=1
151 fi
152 done
153fi
jeffhao5d1ac922011-09-29 17:41:15 -0700154
TDYa127b92bcab2012-04-08 00:09:51 -0700155echo "succeeded tests: $succeeded_count"
Elliott Hughes8cbc8bc2011-10-04 11:19:45 -0700156echo "failed tests: $failure_count"
157
158for i in $failed_test_names; do
159 echo "failed: $i"
jeffhao5d1ac922011-09-29 17:41:15 -0700160done